"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var cli_1 = require("@prisma/cli");
var chalk_1 = require("chalk");
var fs = require("fs");
var ora_1 = require("ora");
var path = require("path");
var prisma_cli_engine_1 = require("prisma-cli-engine");
var prisma_datamodel_1 = require("prisma-datamodel");
var prisma_yml_1 = require("prisma-yml");
var PrismaDefinition_1 = require("./prisma-config/PrismaDefinition");
var util_1 = require("./introspect/util");
var CredentialPrompt_1 = require("./prompts/CredentialPrompt");
var Introspect = /** @class */ (function () {
    function Introspect() {
        this.config = new prisma_cli_engine_1.Config();
        this.out = new prisma_yml_1.Output();
        this.env = new prisma_yml_1.Environment(this.config.home, this.out, this.config.version);
        this.definition = new PrismaDefinition_1.PrismaDefinitionClass(this.env, this.config.definitionPath, process.env, this.out);
    }
    Introspect.new = function () {
        return new Introspect();
    };
    Introspect.prototype.parse = function (argv) {
        return __awaiter(this, void 0, void 0, function () {
            var args, sdl, _a, newDatamodelSdl, numTables, referenceDatamodelExists, fileName, andDatamodelText, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        args = cli_1.arg(argv, {
                            '--interactive': Boolean,
                            '-i': '--interactive',
                            '--env-file': String,
                            '-e': '--env-file',
                            '--project': String,
                            '-p': '--project',
                            '--help': Boolean,
                            '-h': '--help',
                            /**
                             * Postgres Params
                             */
                            '--pg-host': String,
                            '--pg-port': String,
                            '--pg-user': String,
                            '--pg-password': String,
                            '--pg-db': String,
                            '--pg-ssl': Boolean,
                            '--pg-schema': String,
                            /**
                             * MySQL Params
                             */
                            '--mysql-host': String,
                            '--mysql-port': String,
                            '--mysql-user': String,
                            '--mysql-password': String,
                            '--mysql-db': String,
                            /**
                             * Mongo Params
                             */
                            '--mongo-uri': String,
                            '--mongo-db': String,
                            '--sdl': Boolean,
                        });
                        if (cli_1.isError(args)) {
                            return [2 /*return*/, null];
                        }
                        if (args['--help']) {
                            return [2 /*return*/, this.help()];
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 7, , 8]);
                        sdl = args['--sdl'];
                        return [4 /*yield*/, this.getConnectorWithDatabase(args, sdl)];
                    case 2:
                        _a = _b.sent(), newDatamodelSdl = _a.sdl, numTables = _a.numTables, referenceDatamodelExists = _a.referenceDatamodelExists;
                        if (!!sdl) return [3 /*break*/, 5];
                        fileName = this.writeDatamodel(newDatamodelSdl);
                        console.log("Created datamodel definition based on " + numTables + " database tables.");
                        andDatamodelText = referenceDatamodelExists
                            ? ' and the existing datamodel'
                            : '';
                        console.log(chalk_1.default.bold('Created 1 new file:') + "    GraphQL SDL-based datamodel (derived from existing database" + andDatamodelText + ")\n\n  " + chalk_1.default.cyan(fileName) + "\n");
                        if (!(this.definition.definition &&
                            !this.definition.definition.datamodel)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.definition.load(args)];
                    case 3:
                        _b.sent();
                        this.definition.addDatamodel(fileName);
                        console.log("Added " + chalk_1.default.bold("datamodel: " + fileName) + " to prisma.yml");
                        _b.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        console.log(newDatamodelSdl);
                        _b.label = 6;
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        e_1 = _b.sent();
                        console.log(chalk_1.default.red("\n" + chalk_1.default.bold("Error: " + e_1.message)));
                        return [3 /*break*/, 8];
                    case 8:
                        // TODO: process.exit is needed because some listeners are probably not cleared properly
                        process.exit(0);
                        return [2 /*return*/];
                }
            });
        });
    };
    Introspect.prototype.getExistingDatamodel = function (databaseType) {
        if (this.definition.typesString) {
            var ParserInstance = prisma_datamodel_1.DefaultParser.create(databaseType);
            return ParserInstance.parseFromSchemaString(this.definition.typesString);
        }
        return null;
    };
    Introspect.prototype.introspect = function (_a) {
        var connector = _a.connector, databaseType = _a.databaseType, databaseName = _a.databaseName;
        return __awaiter(this, void 0, void 0, function () {
            var existingDatamodel, introspection, sdl, _b, renderer, renderedSdl, numTables;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        existingDatamodel = this.getExistingDatamodel(databaseType);
                        return [4 /*yield*/, connector.introspect(databaseName)];
                    case 1:
                        introspection = _c.sent();
                        if (!existingDatamodel) return [3 /*break*/, 3];
                        return [4 /*yield*/, introspection.getNormalizedDatamodel(existingDatamodel)];
                    case 2:
                        _b = _c.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, introspection.getNormalizedDatamodel()];
                    case 4:
                        _b = _c.sent();
                        _c.label = 5;
                    case 5:
                        sdl = _b;
                        renderer = prisma_datamodel_1.DefaultRenderer.create(introspection.databaseType, true);
                        renderedSdl = renderer.render(sdl);
                        numTables = sdl.types.length;
                        if (numTables === 0) {
                            throw new Error("The provided database doesn't contain any tables. Please provide another database.");
                        }
                        return [2 /*return*/, {
                                sdl: renderedSdl,
                                numTables: numTables,
                                referenceDatamodelExists: Boolean(existingDatamodel),
                            }];
                }
            });
        });
    };
    Introspect.prototype.writeDatamodel = function (renderedSdl) {
        var fileName = "datamodel-" + new Date().getTime() + ".prisma";
        var fullFileName = path.join(this.config.definitionDir, fileName);
        fs.writeFileSync(fullFileName, renderedSdl);
        return fileName;
    };
    Introspect.prototype.getConnectorWithDatabase = function (args, sdl) {
        return __awaiter(this, void 0, void 0, function () {
            var credentialsByFlag, connectorData, _a, connector, disconnect, schemas, introspectionResult;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        credentialsByFlag = this.getCredentialsByFlags(args);
                        if (!!credentialsByFlag) return [3 /*break*/, 2];
                        return [4 /*yield*/, CredentialPrompt_1.promptIntrospectionInteractively(this.introspect.bind(this))];
                    case 1:
                        connectorData = _b.sent();
                        return [2 /*return*/, connectorData];
                    case 2:
                        // Get connector from flags
                        if (!credentialsByFlag.schema) {
                            console.log("Please provide a database name");
                            return [2 /*return*/, process.exit(1)];
                        }
                        return [4 /*yield*/, util_1.getConnectedConnectorFromCredentials(credentialsByFlag)];
                    case 3:
                        _a = _b.sent(), connector = _a.connector, disconnect = _a.disconnect;
                        return [4 /*yield*/, util_1.getDatabaseSchemas(connector)];
                    case 4:
                        schemas = _b.sent();
                        util_1.assertSchemaExists(credentialsByFlag.schema, credentialsByFlag.type, schemas);
                        return [4 /*yield*/, this.introspectWithSpinner({
                                connector: connector,
                                disconnect: disconnect,
                                databaseType: credentialsByFlag.type,
                                databaseName: credentialsByFlag.schema,
                            }, sdl)];
                    case 5:
                        introspectionResult = _b.sent();
                        return [4 /*yield*/, disconnect()];
                    case 6:
                        _b.sent();
                        return [2 /*return*/, introspectionResult];
                }
            });
        });
    };
    Introspect.prototype.getCredentialsByFlags = function (args) {
        var requiredPostgresFlags = [
            '--pg-host',
            '--pg-user',
            '--pg-password',
            '--pg-db',
        ];
        var requiredMysqlFlags = [
            '--mysql-host',
            '--mysql-user',
            '--mysql-password',
        ];
        var flagsKeys = Object.keys(args);
        var mysqlFlags = flagsKeys.filter(function (f) { return requiredMysqlFlags.includes(f); });
        var postgresFlags = flagsKeys.filter(function (f) {
            return requiredPostgresFlags.includes(f);
        });
        if (mysqlFlags.length > 0 && postgresFlags.length > 0) {
            throw new Error("You can't provide both MySQL and Postgres connection flags. Please provide either of both.");
        }
        if (mysqlFlags.length > 0 &&
            mysqlFlags.length < requiredMysqlFlags.length) {
            this.handleMissingArgs(requiredMysqlFlags, mysqlFlags, 'mysql');
        }
        if (postgresFlags.length > 0 &&
            postgresFlags.length < requiredPostgresFlags.length) {
            this.handleMissingArgs(requiredPostgresFlags, postgresFlags, 'pg');
        }
        if (mysqlFlags.length >= requiredMysqlFlags.length) {
            return {
                host: args['--mysql-host'],
                port: parseInt(args['--mysql-port'], 10),
                user: args['--mysql-user'],
                password: args['--mysql-password'],
                schema: args['--mysql-db'],
                type: prisma_datamodel_1.DatabaseType.mysql,
            };
        }
        if (postgresFlags.length >= requiredPostgresFlags.length) {
            return {
                host: args['--pg-host'],
                user: args['--pg-user'],
                password: args['--pg-password'],
                database: args['--pg-db'],
                port: parseInt(args['--pg-port'], 10),
                schema: args['--pg-schema'],
                type: prisma_datamodel_1.DatabaseType.postgres,
            }; // this is optional and can be undefined
        }
        if (args['--mongo-uri']) {
            var uri = args['--mongo-uri'];
            var database = args['--mongo-db']; // this is optional and can be undefined
            var credentials = util_1.populateMongoDatabase({
                uri: uri,
                database: database,
            });
            return {
                uri: util_1.sanitizeMongoUri(credentials.uri),
                schema: credentials.database,
                type: prisma_datamodel_1.DatabaseType.mongo,
            };
        }
        return null;
    };
    Introspect.prototype.handleMissingArgs = function (requiredArgs, providedArgs, prefix) {
        var missingArgs = requiredArgs.filter(function (arg) { return !providedArgs.some(function (provided) { return arg === provided; }); });
        throw new Error("If you provide one of the " + prefix + "- arguments, you need to provide all of them. The arguments " + missingArgs.join(', ') + " are missing.");
    };
    /**
     * Introspect the database
     */
    Introspect.prototype.introspectWithSpinner = function (connectorData, sdl) {
        return __awaiter(this, void 0, void 0, function () {
            var spinner, before, introspectionResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        spinner = ora_1.default({ color: 'blue' });
                        before = Date.now();
                        if (!sdl) {
                            spinner.start("Introspecting database " + chalk_1.default.bold(connectorData.databaseName));
                        }
                        return [4 /*yield*/, this.introspect(connectorData)];
                    case 1:
                        introspectionResult = _a.sent();
                        if (!sdl) {
                            spinner.succeed("Introspecting database " + chalk_1.default.bold(connectorData.databaseName) + ": " + util_1.prettyTime(Date.now() - before));
                        }
                        return [2 /*return*/, introspectionResult];
                }
            });
        });
    };
    Introspect.prototype.help = function () {
        return console.log(cli_1.format("\nUsage: prisma introspect [flags]\n\nIntrospect database schema(s) of service\n\nFlags:\n         -e, --env-file ENV-FILE    Path to .env file to inject env vars\n               -i, --interactive    Interactive mode\n           -p, --project PROJECT    Path to Prisma definition file\n             --mongo-db MONGO-DB    Mongo database\n           --mongo-uri MONGO-URI    Mongo connection string\n             --mysql-db MYSQL-DB    The MySQL database\n         --mysql-host MYSQL-HOST    Name of the MySQL host\n --mysql-password MYSQL-PASSWORD    The MySQL password\n         --mysql-port MYSQL-PORT    The MySQL port. Default: 3306\n         --mysql-user MYSQL-USER    The MySQL user\n                   --pg-db PG-DB    The Postgres database\n               --pg-host PG-HOST    Name of the Postgres host\n       --pg-password PG-PASSWORD    The Postgres password\n               --pg-port PG-PORT    The Postgres port. Default: 5432\n           --pg-schema PG-SCHEMA    Name of the Postgres schema\n                        --pg-ssl    Enable ssl for postgres\n               --pg-user PG-USER    The Postgres user\n                           --sdl    Omit any CLI output and just print the resulting datamodel. Requires an existing Prisma project with executeRaw. Useful for scripting\n    "));
    };
    return Introspect;
}());
exports.Introspect = Introspect;
// async function run() {
//   await Introspect.new().parse(process.argv.slice(2))
// }
// run()
//# sourceMappingURL=index.js.map