import { PrismaDefinition } from 'prisma-json-schema';
import { Args, Cluster, Environment, IOutput } from 'prisma-yml';
import { ParseEndpointResult } from 'prisma-yml/dist/utils/parseEndpoint';
export interface EnvVars {
    [key: string]: string | undefined;
}
export declare class PrismaDefinitionClass {
    definition?: PrismaDefinition;
    rawJson?: any;
    typesString?: string;
    secrets: string[] | null;
    definitionPath?: string | null;
    definitionDir: string;
    env: Environment;
    out?: IOutput;
    envVars: any;
    rawEndpoint?: string;
    private definitionString;
    constructor(env: Environment, definitionPath?: string | null, envVars?: EnvVars, out?: IOutput);
    load(args: Args, envPath?: string, graceful?: boolean): Promise<void>;
    private loadDefinition;
    readonly endpoint: string | undefined;
    readonly clusterBaseUrl: string | undefined;
    readonly service: string | undefined;
    readonly stage: string | undefined;
    readonly cluster: string | undefined;
    validate(): void;
    getToken(serviceName: string, stageName: string): string | undefined;
    getCluster(throws?: boolean): Promise<Cluster | undefined>;
    findClusterByBaseUrl(baseUrl: string): Cluster | undefined;
    getClusterByEndpoint(data: ParseEndpointResult): Promise<Cluster>;
    getTypesString(definition: PrismaDefinition): string;
    getClusterName(): string | null;
    getWorkspace(): string | null;
    addDatamodel(datamodel: string): void;
}
export declare function concatName(cluster: Cluster, name: string, workspace: string | null): string;
