"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var ink_1 = require("ink");
var React = require("react");
var Checkbox_1 = require("./Checkbox");
var Divider_1 = require("./Divider");
var helpers_1 = require("./helpers");
var SelectItem_1 = require("./SelectItem");
var TextInput_1 = require("./TextInput");
var useStdin_1 = require("./useStdin");
exports.Prompt = function (props) {
    var _a = __read(React.useState(props.initialFormValues || {}), 2), formValues = _a[0], setFormValues = _a[1];
    var _b = __read(React.useState({}), 2), spinnersByCursor = _b[0], setSpinnerByCursor = _b[1];
    var _c = __read(React.useState(0), 2), cursor = _c[0], setCursor = _c[1];
    var elementsWithBack = props.withBackButton
        ? __spread(props.elements, [
            {
                label: 'Back',
                style: { marginTop: 1 },
                type: 'select',
                value: undefined,
            },
        ]) : props.elements;
    useStdin_1.useStdin(function (actionKey) {
        setCursor(function (prevCursor) {
            if (actionKey === 'up') {
                return helpers_1.up(prevCursor, elementsWithBack);
            }
            if (actionKey === 'down') {
                return helpers_1.down(prevCursor, elementsWithBack);
            }
            var hoveredElement = elementsWithBack[prevCursor];
            if (actionKey === 'next' && !helpers_1.isElementInput(hoveredElement)) {
                return helpers_1.down(prevCursor, elementsWithBack);
            }
            if (actionKey === 'submit' &&
                helpers_1.isElementInput(hoveredElement) &&
                !!formValues[hoveredElement.identifier]) {
                return helpers_1.down(prevCursor, elementsWithBack);
            }
            if (actionKey === 'submit' &&
                !helpers_1.isElementCheckbox(hoveredElement) &&
                !helpers_1.isElementSelect(hoveredElement) &&
                !helpers_1.isElementInput(hoveredElement)) {
                return helpers_1.down(prevCursor, elementsWithBack);
            }
            return prevCursor;
        });
    }, [cursor, elementsWithBack]);
    var onInputChange = function (value, input) {
        setFormValues(function (prevCredentials) {
            var _a;
            return (__assign({}, prevCredentials, (_a = {}, _a[input.identifier] = value, _a)));
        });
    };
    var addSpinner = function (spinnerCursor) {
        return function (message) {
            setSpinnerByCursor(function (prev) {
                var _a;
                return (__assign({}, prev, (_a = {}, _a[spinnerCursor] = { state: 'running', message: message }, _a)));
            });
        };
    };
    var removeSpinner = function (spinnerCursor) {
        return function (state) {
            setSpinnerByCursor(function (prev) {
                var _a;
                return (__assign({}, prev, (_a = {}, _a[spinnerCursor] = state, _a)));
            });
        };
    };
    var submitPrompt = function (value, goBack, elemIndex) {
        props.onSubmit({
            formValues: formValues,
            selectedValue: value,
            goBack: goBack,
            startSpinner: addSpinner(elemIndex),
            stopSpinner: removeSpinner(elemIndex),
        });
    };
    return (React.createElement(ink_1.Box, { flexDirection: "column" },
        props.title && (React.createElement(ink_1.Box, { marginBottom: 1 },
            React.createElement(ink_1.Text, { bold: true }, props.title))),
        React.createElement(ink_1.Box, { flexDirection: "column", marginLeft: 1, marginBottom: props.withBackButton ? 1 : 0 }, props.elements.map(function (e, elemIndex) {
            if (helpers_1.isElementInput(e)) {
                return (React.createElement(ink_1.Box, __assign({ key: elemIndex }, e.style),
                    React.createElement(TextInput_1.TextInput, __assign({}, e, { value: formValues[e.identifier] || '', focus: cursor === elemIndex, onChange: function (value) { return onInputChange(value, e); } }))));
            }
            if (helpers_1.isElementCheckbox(e)) {
                return (React.createElement(ink_1.Box, __assign({ key: elemIndex }, e.style),
                    React.createElement(Checkbox_1.Checkbox, __assign({}, e, { checked: formValues[e.identifier] || false, onChange: function (value) { return onInputChange(value, e); }, focus: cursor === elemIndex }))));
            }
            if (helpers_1.isElementSeparator(e)) {
                return (React.createElement(ink_1.Box, __assign({ key: elemIndex }, e.style),
                    React.createElement(Divider_1.Divider, { title: e.label || '', dividerChar: e.dividerChar })));
            }
            if (helpers_1.isElementSelect(e)) {
                return (React.createElement(ink_1.Box, __assign({ key: elemIndex }, e.style),
                    React.createElement(SelectItem_1.SelectItem, __assign({}, e, { focus: cursor === elemIndex, spinnerState: spinnersByCursor[elemIndex], onSelect: function (value) { return __awaiter(_this, void 0, void 0, function () {
                            var spinner;
                            return __generator(this, function (_a) {
                                spinner = spinnersByCursor[elemIndex];
                                if (!spinner || spinner.state !== 'running') {
                                    return [2 /*return*/, submitPrompt(value, false, elemIndex)];
                                }
                                return [2 /*return*/];
                            });
                        }); } }))));
            }
            return null;
        })),
        props.withBackButton && (React.createElement(SelectItem_1.SelectItem, { label: "Back", isBackButton: true, onSelect: function () {
                submitPrompt(undefined, true, elementsWithBack.length - 1);
            }, focus: cursor === elementsWithBack.length - 1, spinnerState: undefined }))));
};
//# sourceMappingURL=BoxPrompt.js.map