"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ink_1 = require("ink");
var React = require("react");
var string_width_1 = require("string-width");
// Helpers
var getSideDividerWidth = function (width, titleWidth) {
    return (width - titleWidth) / 2;
};
var getNumberOfCharsPerWidth = function (char, width) {
    return width / string_width_1.default(char);
};
var PAD = ' ';
exports.Divider = function (_a) {
    var title = _a.title, width = _a.width, padding = _a.padding, titlePadding = _a.titlePadding, titleColor = _a.titleColor, dividerChar = _a.dividerChar, dividerColor = _a.dividerColor;
    var titleString = title
        ? "" + (PAD.repeat(titlePadding) + title + PAD.repeat(titlePadding))
        : '';
    var titleWidth = string_width_1.default(titleString);
    var dividerWidth = getSideDividerWidth(width, titleWidth);
    var numberOfCharsPerSide = getNumberOfCharsPerWidth(dividerChar, dividerWidth);
    var dividerSideString = dividerChar.repeat(numberOfCharsPerSide);
    var paddingString = PAD.repeat(padding);
    return (React.createElement(ink_1.Box, null,
        paddingString,
        React.createElement(ink_1.Color, { keyword: dividerColor }, dividerSideString),
        React.createElement(ink_1.Color, { keyword: titleColor }, titleString),
        React.createElement(ink_1.Color, { keyword: dividerColor }, dividerSideString),
        paddingString));
};
exports.Divider.defaultProps = {
    dividerChar: '─',
    dividerColor: 'grey',
    padding: 1,
    title: null,
    titleColor: 'white',
    titlePadding: 1,
    width: 50,
};
//# sourceMappingURL=Divider.js.map