"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var ink_1 = require("ink");
var React = require("react");
var helpers_1 = require("./helpers");
var Spinner_1 = require("./Spinner");
var useStdin_1 = require("./useStdin");
var figures = require("figures");
function renderSelectIndicator(spinnerState, isBackButton) {
    if (isBackButton) {
        return helpers_1.BACK_SYMBOL;
    }
    if (!spinnerState) {
        return figures.pointer;
    }
    if (spinnerState.state === 'running') {
        return React.createElement(Spinner_1.Spinner, null);
    }
    if (spinnerState.state === 'failed') {
        return React.createElement(ink_1.Color, { red: true }, figures.cross);
    }
    if (spinnerState.state === 'succeeded') {
        return React.createElement(ink_1.Color, { green: true }, figures.tick);
    }
    return figures.pointer;
}
var SelectIndicator = function (props) { return (React.createElement(ink_1.Box, { marginRight: 1 }, renderSelectIndicator(props.spinnerState, props.isBackButton))); };
function renderDescription(props) {
    if (props.spinnerState && props.spinnerState.message) {
        if (props.spinnerState.state === 'running' ||
            props.spinnerState.state === 'succeeded') {
            return React.createElement(ink_1.Color, { green: true }, props.spinnerState.message);
        }
        else if (props.spinnerState.state === 'failed') {
            return React.createElement(ink_1.Color, { red: true }, props.spinnerState.message);
        }
    }
    else {
        return React.createElement(ink_1.Color, { dim: true }, props.description || '');
    }
}
exports.SelectItem = function (props) {
    var indicator = (React.createElement(SelectIndicator, { spinnerState: props.spinnerState, isBackButton: props.isBackButton }));
    useStdin_1.useStdin(function (actionKey) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(props.focus && actionKey === 'submit')) return [3 /*break*/, 2];
                    return [4 /*yield*/, props.onSelect(props.value)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); }, [props.focus, props.value]);
    return (React.createElement(ink_1.Box, null,
        props.focus ? React.createElement(ink_1.Color, { green: true }, indicator) : indicator,
        React.createElement(ink_1.Box, { marginLeft: 1 }, props.focus ? (React.createElement(ink_1.Color, { green: true }, props.label.padEnd(20))) : (props.label.padEnd(20))),
        renderDescription(props)));
};
exports.SelectItem.defaultProps = {
    isBackButton: false,
};
//# sourceMappingURL=SelectItem.js.map