/// <reference types="node" />
import { Key } from 'readline';
import { CheckboxElement, InputElement, PromptElement, SelectElement, SeparatorElement } from './types';
export declare function isElementInput(obj: PromptElement): obj is InputElement;
export declare function isElementSelect(obj: PromptElement): obj is SelectElement;
export declare function isElementCheckbox(obj: PromptElement): obj is CheckboxElement;
export declare function isElementSeparator(obj: PromptElement): obj is SeparatorElement;
export declare function down(cursor: number, elements: PromptElement[]): number;
export declare function up(cursor: number, elements: PromptElement[]): number;
export declare type ActionKey = false | 'first' | 'abort' | 'last' | 'reset' | 'submit' | 'delete' | 'deleteForward' | 'next' | 'nextPage' | 'prevPage' | 'up' | 'down' | 'right' | 'left';
export declare function action(key: Key): ActionKey;
export declare const BACK_SYMBOL: string;
