"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isElementInput(obj) {
    return obj && obj.type === 'text-input';
}
exports.isElementInput = isElementInput;
function isElementSelect(obj) {
    return obj && obj.type === 'select';
}
exports.isElementSelect = isElementSelect;
function isElementCheckbox(obj) {
    return obj && obj.type === 'checkbox';
}
exports.isElementCheckbox = isElementCheckbox;
function isElementSeparator(obj) {
    return obj && obj.type === 'separator';
}
exports.isElementSeparator = isElementSeparator;
function down(cursor, elements) {
    var length = elements.length;
    while (cursor < length - 1 &&
        ['separator'].includes(elements[cursor + 1].type)) {
        cursor++;
    }
    return cursor < length - 1 ? cursor + 1 : cursor;
}
exports.down = down;
function up(cursor, elements) {
    while (cursor > 0 && ['separator'].includes(elements[cursor - 1].type)) {
        cursor--;
    }
    return cursor > 0 ? cursor - 1 : cursor;
}
exports.up = up;
function action(key) {
    if (key.ctrl) {
        if (key.name === 'a')
            return 'first';
        if (key.name === 'c')
            return 'abort';
        if (key.name === 'd')
            return 'abort';
        if (key.name === 'e')
            return 'last';
        if (key.name === 'g')
            return 'reset';
    }
    if (key.name === 'return')
        return 'submit';
    if (key.name === 'enter')
        return 'submit'; // ctrl + J
    if (key.name === 'backspace')
        return 'delete';
    if (key.name === 'delete')
        return 'deleteForward';
    if (key.name === 'abort')
        return 'abort';
    if (key.name === 'escape')
        return 'abort';
    if (key.name === 'tab')
        return 'next';
    if (key.name === 'pagedown')
        return 'nextPage';
    if (key.name === 'pageup')
        return 'prevPage';
    if (key.name === 'up')
        return 'up';
    if (key.name === 'down')
        return 'down';
    if (key.name === 'right')
        return 'right';
    if (key.name === 'left')
        return 'left';
    return false;
}
exports.action = action;
exports.BACK_SYMBOL = process.platform !== 'win32' ? '❮' : '<';
//# sourceMappingURL=helpers.js.map