"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ink_1 = require("ink");
var React = require("react");
var helpers_1 = require("./helpers");
function useStdin(keyHandler, deps) {
    if (deps === void 0) { deps = []; }
    var _a = React.useContext(ink_1.StdinContext), stdin = _a.stdin, setRawMode = _a.setRawMode;
    var didCancel = false;
    React.useEffect(function () {
        function handler(_, key) {
            if (!didCancel) {
                keyHandler(helpers_1.action(key));
            }
        }
        setRawMode(true);
        stdin.on('keypress', handler);
        return function () {
            didCancel = true;
            stdin.removeListener('keypress', handler);
            setRawMode(false);
        };
    }, [stdin, setRawMode, deps]);
    return didCancel;
}
exports.useStdin = useStdin;
//# sourceMappingURL=useStdin.js.map