"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var _a;
var ink_1 = require("ink");
var prisma_datamodel_1 = require("prisma-datamodel");
var React = require("react");
var util_1 = require("../introspect/util");
var BoxPrompt_1 = require("../prompt-lib/BoxPrompt");
var prompts_elements_1 = require("./prompts-elements");
var Steps;
(function (Steps) {
    Steps[Steps["CHOOSE_DB"] = 0] = "CHOOSE_DB";
    Steps[Steps["CONNECT_DB"] = 1] = "CONNECT_DB";
    Steps[Steps["CHOOSE_SCHEMA"] = 2] = "CHOOSE_SCHEMA";
})(Steps || (Steps = {}));
var initialState = {
    step: Steps.CHOOSE_DB,
    credentials: {},
    connectorData: {},
    schemas: [],
};
var reducer = function (state, action) {
    switch (action.type) {
        case 'choose_db':
            return __assign({}, state, { step: Steps.CONNECT_DB, credentials: __assign({}, state.credentials, { type: action.payload }) });
        case 'connect_db':
            return __assign({}, state, { step: Steps.CHOOSE_SCHEMA, credentials: __assign({}, state.credentials, action.payload.credentials), schemas: action.payload.schemas, connectorData: action.payload.connectorAndDisconnect });
        case 'back':
            return __assign({}, state, { step: action.payload.prevStep, credentials: !action.payload.credentials
                    ? state.credentials
                    : __assign({}, state.credentials, action.payload.credentials) });
    }
};
var dbTypeTodbName = (_a = {},
    _a[prisma_datamodel_1.DatabaseType.postgres] = 'Postgres',
    _a[prisma_datamodel_1.DatabaseType.mysql] = 'MySQL',
    _a[prisma_datamodel_1.DatabaseType.mongo] = 'MongoDB',
    _a[prisma_datamodel_1.DatabaseType.sqlite] = 'SQLite',
    _a);
/**
 * WARNING: If you add more steps, make sure to add a `key` to the `<Prompt />`, otherwise the state between each prompt will be shared
 */
var IntrospectionPrompt = function (props) {
    var _a = __read(React.useReducer(reducer, initialState), 2), state = _a[0], dispatch = _a[1];
    switch (state.step) {
        case Steps.CHOOSE_DB:
            return (React.createElement(BoxPrompt_1.Prompt, { key: Steps.CHOOSE_DB, title: "What kind of database do you want to introspect?", elements: prompts_elements_1.CHOOSE_DB_ELEMENTS, onSubmit: function (_a) {
                    var selectedValue = _a.selectedValue;
                    dispatch({
                        type: 'choose_db',
                        payload: selectedValue,
                    });
                }, withBackButton: false }));
        case Steps.CONNECT_DB:
            return (React.createElement(BoxPrompt_1.Prompt, { key: Steps.CONNECT_DB, elements: prompts_elements_1.CONNECT_DB_ELEMENTS(state.credentials.type), title: "Enter the " + dbTypeTodbName[state.credentials.type] + " credentials", initialFormValues: state.credentials, onSubmit: onConnectOrTest(state, dispatch), withBackButton: true }));
        case Steps.CHOOSE_SCHEMA:
            return (React.createElement(BoxPrompt_1.Prompt, { key: Steps.CHOOSE_SCHEMA, title: "Select the schema you want to introspect", onSubmit: function (_a) {
                    var selectedValue = _a.selectedValue, goBack = _a.goBack, startSpinner = _a.startSpinner, stopSpinner = _a.stopSpinner;
                    return __awaiter(_this, void 0, void 0, function () {
                        var introspectionResult, e_1;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    if (goBack) {
                                        return [2 /*return*/, dispatch({
                                                type: 'back',
                                                payload: { prevStep: Steps.CONNECT_DB },
                                            })];
                                    }
                                    _b.label = 1;
                                case 1:
                                    _b.trys.push([1, 4, , 5]);
                                    startSpinner("Introspecting " + selectedValue);
                                    return [4 /*yield*/, props.introspect(__assign({}, state.connectorData, { databaseName: selectedValue }))];
                                case 2:
                                    introspectionResult = _b.sent();
                                    return [4 /*yield*/, state.connectorData.disconnect()];
                                case 3:
                                    _b.sent();
                                    props.onSubmit(introspectionResult);
                                    return [3 /*break*/, 5];
                                case 4:
                                    e_1 = _b.sent();
                                    stopSpinner({ state: 'failed', message: e_1.message });
                                    return [3 /*break*/, 5];
                                case 5: return [2 /*return*/];
                            }
                        });
                    });
                }, withBackButton: true, elements: state.schemas.map(function (schema) {
                    return ({
                        type: 'select',
                        label: schema,
                        value: schema,
                    });
                }) }));
    }
};
function onConnectOrTest(state, dispatch) {
    var _this = this;
    return function (params) { return __awaiter(_this, void 0, void 0, function () {
        var newCredentials;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    newCredentials = __assign({}, state.credentials, params.formValues);
                    if (params.goBack) {
                        return [2 /*return*/, dispatch({
                                type: 'back',
                                payload: {
                                    prevStep: Steps.CHOOSE_DB,
                                    credentials: newCredentials,
                                },
                            })];
                    }
                    if (!(params.selectedValue === '__TEST__')) return [3 /*break*/, 2];
                    return [4 /*yield*/, onTest(params, newCredentials)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    if (!(params.selectedValue === '__CONNECT__')) return [3 /*break*/, 4];
                    return [4 /*yield*/, onConnect(params, newCredentials, dispatch)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    }); };
}
function onConnect(params, credentials, dispatch) {
    return __awaiter(this, void 0, void 0, function () {
        var connectorAndDisconnect, schemas, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    params.startSpinner();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, util_1.getConnectedConnectorFromCredentials(credentials)];
                case 2:
                    connectorAndDisconnect = _a.sent();
                    return [4 /*yield*/, util_1.getDatabaseSchemas(connectorAndDisconnect.connector)];
                case 3:
                    schemas = _a.sent();
                    params.stopSpinner({ state: 'succeeded' });
                    if (schemas) {
                        dispatch({
                            type: 'connect_db',
                            payload: {
                                schemas: schemas,
                                connectorAndDisconnect: connectorAndDisconnect,
                                credentials: credentials,
                            },
                        });
                    }
                    return [3 /*break*/, 5];
                case 4:
                    e_2 = _a.sent();
                    params.stopSpinner({ state: 'failed', message: e_2.message }); // TODO: Display error message on the prompt
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    });
}
function onTest(params, credentials) {
    return __awaiter(this, void 0, void 0, function () {
        var e_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    params.startSpinner();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, util_1.getConnectedConnectorFromCredentials(credentials)];
                case 2:
                    _a.sent();
                    params.stopSpinner({ state: 'succeeded' });
                    return [3 /*break*/, 4];
                case 3:
                    e_3 = _a.sent();
                    params.stopSpinner({ state: 'failed', message: e_3.message });
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function promptIntrospectionInteractively(introspect) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        ink_1.render(React.createElement(IntrospectionPrompt, { introspect: introspect, onSubmit: resolve }));
                        return [2 /*return*/];
                    });
                }); })];
        });
    });
}
exports.promptIntrospectionInteractively = promptIntrospectionInteractively;
//# sourceMappingURL=CredentialPrompt.js.map